package com.seeyon.ctp.common.template.manager;

import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.GlobalNames;
import com.seeyon.ctp.common.ModuleType;
import com.seeyon.ctp.common.authenticate.domain.User;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.po.template.CtpTemplate;
import com.seeyon.ctp.common.po.template.CtpTemplateHistory;
import com.seeyon.ctp.organization.bo.V3xOrgAccount;
import com.seeyon.ctp.organization.bo.V3xOrgMember;
import com.seeyon.ctp.organization.manager.OrgManager;

/**  
* <p>Title: TemplateReleaseColHandler.java</p>  
* <p>Copyright: Copyright (c) 2018</p>  
* <p>Company: www.seeyon.com</p>  
* @author muj  
* @date 2018年12月7日  
* @version 1.0  
*/
public class TemplateReleaseColHandler extends TemplateReleaseHandler {

	private FormTemplateDesignManager formTemplateDesignManager;
	
	


	public FormTemplateDesignManager getFormTemplateDesignManager() {
		return formTemplateDesignManager;
	}

	public void setFormTemplateDesignManager(FormTemplateDesignManager formTemplateDesignManager) {
		this.formTemplateDesignManager = formTemplateDesignManager;
	}

	@Override
	public ModuleType getModuleType() {
		return ModuleType.collaboration;
	}

	@Override
	public void doWhenRelease(CtpTemplate template, CtpTemplateHistory history) throws BusinessException {

	    User user = AppContext.getCurrentUser();
	    boolean initUser = false;
	    if(user == null) {

	        initUser = true;
	        
	        // 需要初始化用户
            OrgManager orgManager = (OrgManager) AppContext.getBean("orgManager");
            Long memberId = history.getModifyMember();
            if(memberId == null) {
                memberId = history.getMemberId();
            }
            V3xOrgMember member = orgManager.getMemberById(memberId);
	        
	        user = new User();
	        
	        user.setId(member.getId());
	        user.setName(member.getName());
	        user.setAccountId(member.getOrgAccountId());
	        user.setDepartmentId(member.getOrgDepartmentId());
	        user.setLoginName(member.getLoginName());
	        user.setLevelId(member.getOrgLevelId());
	        user.setPostId(member.getOrgPostId());
	        
	        //登录单位信息设置
	        V3xOrgAccount account = orgManager.getAccountById(member.getOrgAccountId());
	        
	        user.setLoginAccount(account.getId());
	        user.setLoginAccountName(account.getName());
	        user.setLoginAccountShortName(account.getShortName());
	        
	        user.setRemoteAddr("127.0.0.1");
	        
	        AppContext.putThreadContext(GlobalNames.SESSION_CONTEXT_USERINFO_KEY, user);
	    }
	    
	    try {
	        formTemplateDesignManager.cloneAndSaveTemplateHistoryToTemplate(template,history,false,false);
	    }finally {
	        if(initUser) {
	            AppContext.removeThreadContext(GlobalNames.SESSION_CONTEXT_USERINFO_KEY);
	        }
        }
	}

}
