package com.seeyon.ctp.common.web.filter;

import java.io.PrintWriter;
import java.util.Arrays;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.i18n.ResourceUtil;
/**
 * Servlet身份校验。
 * @author wangwenyou
 *
 */
public class ServletAuthenticator extends AbstractAuthenticator {
	private static Log LOG = LogFactory.getLog(ServletAuthenticator.class);
	@Override
	public void afterFailure(HttpServletRequest request, HttpServletResponse response) throws Exception {
		String uri = request.getRequestURI().substring(8);
		if(uri.endsWith(".psml")) {
			// PortalServlet
			PrintWriter out = response.getWriter();
			out.println("<script type=\"text/javascript\" charset=\"UTF-8\" src=\"" + request.getContextPath()
					+ "/common/js/V3X.js\"></script>");
			out.println("<script>");
			// 刷新空间
			out.println("alert(\"" + ResourceUtil.getString("loginUserState.unknown") + "\");");
			out.println("if(getA8Top){getA8Top().location.href =\"" + request.getContextPath()
					+ "/main.do?method=logout\";}\n");
			out.println("</script>");
			out.close();
		}else {
			super.afterFailure(request, response);
		}
	}
	// Servlet列表
	private static List<String> servlets = Arrays.asList("getAJAXMessageServlet",
			"getAJAXOnlineServlet", "htmlofficeservlet", "isignaturehtmlH5servlet", "isignaturehtmlservlet",
			"login/sso", "login/ssologout", "m-signature/", "ofdServlet", "office/cache/", "officeservlet",
			"pdfservlet", "sursenServlet", "verifyCodeImage.jpg");
	// 可匿名访问的白名单
	private static List<String> anonymousWhiteList = Arrays.asList("login/sso","verifyCodeImage.jpg","thirdparyServlet");

	@Override
	public boolean authenticate(HttpServletRequest request, HttpServletResponse response) throws Exception {
		AppContext.initSystemEnvironmentContext(request, response);
	    if(AppContext.getCurrentUser() != null) {
	    	return true;
	    }
		String uri = request.getRequestURI().substring(8);
		for (String string : anonymousWhiteList) {
			if (uri.startsWith(string)) {
				return true;
			}
		}
		HttpSession session = request.getSession(false);
		String sessionId = session!=null ? session.getId() : "";
		LOG.warn("servlet " + uri + "'s anonymous access fail:" + sessionId);
	    return false;
	}
	public static boolean accept(HttpServletRequest request) {
		String uri = request.getRequestURI().substring(8);
		if(uri.endsWith(".psml")) {
			return true;
		}
		for (String string : servlets) {
			if (uri.startsWith(string)) {
				return true;
			}
		}
		return false;
	}
}
