package com.seeyon.ctp.portal.sso;

import com.seeyon.ctp.common.SystemEnvironment;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.web.client.RestTemplate;

import java.io.*;
import java.net.URLDecoder;
import java.util.*;

public class MySSOLoginHandshake extends SSOLoginHandshakeAbstract {
    private static final Log log = LogFactory.getLog(MySSOLoginHandshake.class);
    // “ticket” 就是ticket取得的参数值
    public String handshake(String code){
        JSONObject jsonObject = new JSONObject();
        String decodeRs = null ;
        if (StringUtils.isEmpty(code))
        {
            log.error( "单点登录缺少登录票据[ticket]信息!");
            return null;
        }
        // 认证服务器地址
        String ssoUrl = "";
        String clientId = "";
        String redirectUri = "";
        String clientSecret = "";
        String filePath = SystemEnvironment.getApplicationFolder() + File.separator + "fkmap" + File.separator + "url.properties" ;
        InputStream in = null;
        try {
            in = new BufferedInputStream(new FileInputStream(filePath));
            Properties p = new Properties();
            p.load(in);
            ssoUrl = p.getProperty("ssoUrl");
            clientId = p.getProperty("clientId");
            redirectUri = p.getProperty("redirectUri");
            clientSecret = p.getProperty("clientSecret");
        } catch (Exception e) {
            e.printStackTrace();
        }
        log.info("sso code: " + code);
        String grantType = "authorization_code"; //必填 常量
        String userName = "";
        String token = "";
        //使用认证中心的code获取token
        String getSSOTokenUrl = ssoUrl + "accessToken?" +
                "client_id=" + clientId +
                "&grant_type=" + grantType +
                "&redirect_uri=" + redirectUri +
                "&oauth_timestamp="+ (new Date()).getTime() +
                "&code=" + code +
                "&client_secret=" + clientSecret;
        log.info("get sso token url: "+getSSOTokenUrl);
        RestTemplate rest = new RestTemplate();
        String  respnose = rest.postForObject(getSSOTokenUrl,null, String.class);
//        String code = "";
        if(StringUtils.isNotBlank(respnose)){
            try {
                decodeRs = URLDecoder.decode(respnose, "UTF-8");
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
                log.error("error");
            }
            jsonObject = JSONObject.fromObject(decodeRs.replace("\r\n",""));
        }
        log.info("sso token: " + respnose);
        token = (String) jsonObject.get("access_token");
        log.info("sso token1: " + token);

        //使用token获取用户信息
        String getUserUrl = ssoUrl + "profile?access_token=" + token;
        log.info("get user url: "+getUserUrl);
        RestTemplate rest1 = new RestTemplate();
        respnose = rest1.getForObject(getUserUrl,String.class);
        if(StringUtils.isNotBlank(respnose)){
            try {
                decodeRs = URLDecoder.decode(respnose, "UTF-8");
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
                log.error("error1");
            }
            jsonObject = JSONObject.fromObject(decodeRs.replace("\r\n",""));
        }
        log.info("user info: " + respnose);
//        JSONObject userObj = JSONObject.fromObject(userResult);
        userName = (String) jsonObject.get("id");
        log.info("userName info: " + userName);
        return userName;
    }
    public void logoutNotify(String ticket) {
        log.info("退出登录："+ticket);
    }

}