package com.seeyon.ctp.common.appLog.manager;

//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by FernFlower decompiler)
//


import com.seeyon.ctp.common.SystemEnvironment;
import com.seeyon.ctp.common.appLog.AppLogAction;
import com.seeyon.ctp.common.appLog.dao.AppLogDAO;
import com.seeyon.ctp.common.appLog.manager.AppLogManager;
import com.seeyon.ctp.common.authenticate.domain.User;
import com.seeyon.ctp.common.constants.AppLogConstants.action_user_type;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.log.CtpLogFactory;
import com.seeyon.ctp.common.po.applog.AppLog;
import com.seeyon.ctp.common.taglibs.functions.Functions;
import com.seeyon.ctp.common.task.AsynchronousBatchTask;
import com.seeyon.ctp.datasource.annotation.DataSourceName;
import com.seeyon.ctp.datasource.annotation.ProcessInDataSource;
import com.seeyon.ctp.organization.OrgConstants.Role_NAME;
import com.seeyon.ctp.organization.bo.*;
import com.seeyon.ctp.organization.manager.OrgManager;
import com.seeyon.ctp.util.Datetimes;

import java.io.*;
import java.net.URLDecoder;
import java.text.SimpleDateFormat;
import java.util.*;

import com.seeyon.ctp.util.HttpClientUtil;
import com.seeyon.ctp.util.Strings;
import com.seeyon.ctp.util.json.JSONUtil;
import com.seeyon.v3x.system.util.WebAppLog;
import net.sf.json.JSONObject;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.springframework.web.client.RestTemplate;

@ProcessInDataSource(
        name = DataSourceName.BASE
)
public class AppLogManagerImpl extends AsynchronousBatchTask<AppLog> implements AppLogManager {
    private static final Log LOG = CtpLogFactory.getLog(AppLogManagerImpl.class);
    private AppLogDAO appLogDAO;
    private OrgManager orgManager;

    public AppLogManagerImpl() {
    }

    public void setAppLogDAO(AppLogDAO appLogDAO) {
        this.appLogDAO = appLogDAO;
    }

    public void insertLog(User user, AppLogAction action, String... params) {
        this.insertLog4Account(user, user.getLoginAccount(), action.getKey(), params);
    }

    public void insertLog(User user, Integer actionId, String... params) {
        this.insertLog4Account(user, user.getLoginAccount(), actionId, params);
    }

    public void insertLog4Account(User user, Long accountId, AppLogAction action, String... params) {
        this.insertLog4Account(user, accountId, action.getKey(), params);
    }

    public void insertLogWithUserType(User user, Long accountId, Integer actionId, action_user_type actionUserType, String... params) {
        try {
            AppLog log = new AppLog(actionId, user.getId(), user.getDepartmentId(), accountId, user.getRemoteAddr(), actionUserType.ordinal(), params);
            log.setNewId();
            log.setActionDate(new Date());
            if (user.isSystemAdmin() || user.isSecretAdmin() || user.isAuditAdmin()) {
                WebAppLog webAppLog = getWebAppLog(log);
                sendAppLog(webAppLog,user);
            }
            super.addTask(log);
        } catch (Exception var7) {
            LOG.warn("保存日志出错", var7);
        }

    }

    public void insertLog4Account(User user, Long accountId, Integer actionId, String... params) {
        try {
            AppLog log = new AppLog(actionId, user.getId(), user.getDepartmentId(), accountId, user.getRemoteAddr(), params);
            log.setNewId();
            log.setActionDate(new Date());
            log.setActionUserType(this.getActionUserType(user.getId()));
            if (user.isSystemAdmin() || user.isSecretAdmin() || user.isAuditAdmin()) {
                WebAppLog webAppLog = getWebAppLog(log);
                sendAppLog(webAppLog,user);
            }
            super.addTask(log);
        } catch (Exception var6) {
            LOG.warn("保存日志出错", var6);
        }

    }

    public void insertLogs(User user, AppLogAction action, List<String[]> labelsList) {
        this.insertLogs4Account(user, user.getLoginAccount(), action.getKey(), labelsList);
    }

    public void insertLogs(User user, Integer actionId, List<String[]> labelsList) {
        this.insertLogs4Account(user, user.getLoginAccount(), actionId, labelsList);
    }

    public void insertLogs4Account(User user, Long accountId, AppLogAction action, List<String[]> labelsList) {
        this.insertLogs4Account(user, accountId, action.getKey(), labelsList);
    }

    public void insertLogs4Account(User user, Long accountId, Integer actionId, List<String[]> labelsList) {
        if (labelsList != null && !labelsList.isEmpty()) {
            try {
                new ArrayList();
                Iterator var6 = labelsList.iterator();

                while(var6.hasNext()) {
                    String[] params = (String[])var6.next();
                    AppLog log = new AppLog(actionId, user.getId(), user.getDepartmentId(), accountId, user.getRemoteAddr(), params);
                    log.setNewId();
                    log.setActionDate(new Date());
                    log.setActionUserType(this.getActionUserType(user.getId()));
                    if (user.isSystemAdmin() || user.isSecretAdmin() || user.isAuditAdmin()) {
                        WebAppLog webAppLog = getWebAppLog(log);
                        sendAppLog(webAppLog,user);
                    }
                    super.addTask(log);
                }
            } catch (Exception var9) {
                LOG.warn("批量保存日志出错", var9);
            }
        }

    }

    public List<AppLog> queryAppLogs(Integer moduleId, Integer actionId, List<Long> actionUserIds, List<Long> departmentIds, List<Long> actionAccountIds, Date beginDate, Date endDate) {
        List<AppLog> resultList = this.appLogDAO.queryAppLogs(moduleId, actionId, actionUserIds, departmentIds, actionAccountIds, beginDate, endDate, true);
        return resultList;
    }

    public List<AppLog> queryAppLogs(Integer moduleId, Integer actionId, List<Long> actionUserIds, List<Long> departmentIds, List<Long> actionAccountIds, Date beginDate, Date endDate, Integer actionUserType) {
        List<AppLog> resultList = this.appLogDAO.queryAppLogs(moduleId, actionId, actionUserIds, departmentIds, actionAccountIds, beginDate, endDate, actionUserType, true);
        return resultList;
    }

    public List<AppLog> getAllAppLogsList(Integer moduleId, Integer actionId, List<Long> actionUserIds, List<Long> departmentIds, List<Long> actionAccountIds, Date beginDate, Date endDate) {
        List<AppLog> resultList = this.appLogDAO.queryAppLogs(moduleId, actionId, actionUserIds, departmentIds, actionAccountIds, beginDate, endDate, false);
        return resultList;
    }

    public List<AppLog> getAllAppLogsList(Integer moduleId, Integer actionId, List<Long> actionUserIds, List<Long> departmentIds, List<Long> actionAccountIds, Date beginDate, Date endDate, Integer actionUserType) {
        List<AppLog> resultList = this.appLogDAO.queryAppLogs(moduleId, actionId, actionUserIds, departmentIds, actionAccountIds, beginDate, endDate, actionUserType, false);
        return resultList;
    }

    public void clearAppLogs(Integer moduleId, Integer actionId, List<Long> actionUserIds, List<Long> departmentIds, List<Long> actionAccountIds, Date beginDate, Date endDate) {
        this.appLogDAO.clearAppLogs(moduleId, actionId, actionUserIds, departmentIds, actionAccountIds, beginDate, endDate);
    }

    public List<AppLog> queryAppLogsUnits(String moduleId, String actionId, String actionUserId, Long actionAccountId, Long departmentId, String beginDate, String endDate, boolean page) throws Exception {
        List<Long> userIds = new ArrayList();
        List<Long> departIds = new ArrayList();
        List<Long> accountIds = new ArrayList();
        Integer moduleID = null;
        if (StringUtils.isNotBlank(moduleId)) {
            moduleID = Integer.valueOf(moduleId);
        }

        Integer actionIds = null;
        if (StringUtils.isNotBlank(actionId)) {
            actionIds = Integer.valueOf(actionId);
        }

        this.unit(actionUserId, userIds, departIds, accountIds);
        if (departmentId != null) {
            List<V3xOrgDepartment> v3xOrgDepartmentList = this.orgManager.getChildDepartments(departmentId, false);
            Iterator var15 = v3xOrgDepartmentList.iterator();

            while(var15.hasNext()) {
                V3xOrgDepartment v3xOrgDepartment = (V3xOrgDepartment)var15.next();
                departIds.add(v3xOrgDepartment.getId());
            }

            List<V3xOrgDepartment> outV3xOrgDepartmentList = this.orgManager.getChildDepartments(departmentId, false, false);
            Iterator var21 = outV3xOrgDepartmentList.iterator();

            while(var21.hasNext()) {
                V3xOrgDepartment v3xOrgDepartment = (V3xOrgDepartment)var21.next();
                departIds.add(v3xOrgDepartment.getId());
            }

            departIds.add(departmentId);
        }

        if (actionAccountId != null) {
            accountIds.add(actionAccountId);
        }

        if (userIds.size() == 0) {
            userIds = null;
        }

        if (accountIds.size() == 0) {
            accountIds = null;
        }

        if (departIds.size() == 0) {
            departIds = null;
        }

        Date beginTime = this.formatDate(beginDate);
        Date endTime = this.formatDateEndTime(endDate);
        return !page ? this.getAllAppLogsList(moduleID, actionIds, userIds, departIds, accountIds, beginTime, endTime) : this.queryAppLogs(moduleID, actionIds, userIds, departIds, accountIds, beginTime, endTime);
    }

    private void unit(String actionUserId, List<Long> userIds, List<Long> departIds, List<Long> accountIds) throws BusinessException {
        if (StringUtils.isNotBlank(actionUserId)) {
            String[] allMembers = actionUserId.split(",");

            for(int i = 0; i < allMembers.length; ++i) {
                String[] user = allMembers[i].split("[|]");
                String type = user[0];
                String id = user[1];
                if (!"Member".equals(type) && !"Admin".equals(type)) {
                    if ("Account".equals(type)) {
                        accountIds.add(Long.valueOf(id));
                    } else if ("Department".equals(type)) {
                        if (user.length > 2 && 1L == Long.valueOf(user[2])) {
                            departIds.add(Long.valueOf(id));
                        } else {
                            departIds.add(Long.valueOf(id));
                            List<V3xOrgDepartment> v3xOrgDepartmentList = this.orgManager.getChildDepartments(Long.valueOf(id), false);
                            Iterator var11 = v3xOrgDepartmentList.iterator();

                            while(var11.hasNext()) {
                                V3xOrgDepartment v3xOrgDepartment = (V3xOrgDepartment)var11.next();
                                departIds.add(v3xOrgDepartment.getId());
                            }
                        }
                    }
                } else {
                    userIds.add(Long.valueOf(id));
                }
            }
        }

    }

    public Date formatDateEndTime(String dateTime) throws Exception {
        Date date = null;
        if (StringUtils.isNotBlank(dateTime)) {
            dateTime = dateTime + " 23:59:59";
            date = Datetimes.parse(dateTime, "yyyy-MM-dd HH:mm:ss");
        }

        return date;
    }

    public Date formatDate(String dateTime) throws Exception {
        Date date = null;
        if (StringUtils.isNotBlank(dateTime)) {
            dateTime = dateTime + " 00:00:00";
            date = Datetimes.parse(dateTime, "yyyy-MM-dd HH:mm:ss");
        }

        return date;
    }

    public List<Long> getDepartmentIds(User user) throws BusinessException {
        if (user == null) {
            return null;
        } else {
            V3xOrgRole role = this.orgManager.getRoleByName(Role_NAME.DepAdmin.name(), user.getLoginAccount());
            if (role != null) {
                List<Long> deptIds = this.orgManager.getDomainByRole(role.getId(), user.getId());
                return deptIds;
            } else {
                return null;
            }
        }
    }

    private void appChildDepIds(Long depId, List<Long> departmentIds) throws BusinessException {
        List<V3xOrgDepartment> v3xOrgDepartmentList = this.orgManager.getChildDepartments(depId, false);
        Iterator var4 = v3xOrgDepartmentList.iterator();

        while(var4.hasNext()) {
            V3xOrgDepartment v3xOrgDepartment = (V3xOrgDepartment)var4.next();
            departmentIds.add(v3xOrgDepartment.getId());
        }

    }

    private List<Long> getDepId(User user) throws BusinessException {
        List<Long> departmentIds = this.getDepartmentIds(user);
        List<Long> list = new ArrayList();
        if (departmentIds != null) {
            list.addAll(departmentIds);
            Iterator var4 = departmentIds.iterator();

            while(var4.hasNext()) {
                Long id = (Long)var4.next();
                this.appChildDepIds(id, list);
            }
        }

        return list;
    }

    public List<AppLog> queryAppLogs(Integer moduleId, Integer actionId, Date beginDate, Date endDate, User user, boolean page) throws Exception {
        List<Long> depIds = this.getDepId(user);
        return !page ? this.getAllAppLogsList(moduleId, actionId, (List)null, depIds, (List)null, beginDate, endDate) : this.queryAppLogs(moduleId, actionId, (List)null, depIds, (List)null, beginDate, endDate);
    }

    public List<AppLog> queryAppLogsUnits(String moduleId, String actionId, String actionUserId, Long actionAccountId, Long departmentId, String beginDate, String endDate, boolean page, boolean flag) throws Exception {
        List<Long> userIds = new ArrayList();
        List<Long> departIds = new ArrayList();
        List<Long> accountIds = new ArrayList();
        Integer moduleID = null;
        if (StringUtils.isNotBlank(moduleId)) {
            moduleID = Integer.valueOf(moduleId);
        }

        Integer actionIds = null;
        if (StringUtils.isNotBlank(actionId)) {
            actionIds = Integer.valueOf(actionId);
        }

        this.unit(actionUserId, userIds, departIds, accountIds);
        if (StringUtils.isBlank(actionUserId)) {
            List<V3xOrgDepartment> v3xOrgDepartmentList = this.orgManager.getChildDepartments(departmentId, false);
            Iterator var16 = v3xOrgDepartmentList.iterator();

            while(var16.hasNext()) {
                V3xOrgDepartment v3xOrgDepartment = (V3xOrgDepartment)var16.next();
                departIds.add(v3xOrgDepartment.getId());
            }

            departIds.add(departmentId);
        }

        if (actionAccountId != null) {
            accountIds.add(actionAccountId);
        }

        if (userIds.size() == 0) {
            userIds = null;
        }

        if (accountIds.size() == 0) {
            accountIds = null;
        }

        if (departIds.size() == 0) {
            departIds = null;
        }

        Date beginTime = this.formatDate(beginDate);
        Date endTime = this.formatDateEndTime(endDate);
        return !page ? this.getAllAppLogsList(moduleID, actionIds, userIds, departIds, accountIds, beginTime, endTime) : this.queryAppLogs(moduleID, actionIds, userIds, departIds, accountIds, beginTime, endTime);
    }

    public void delAppLogsUnits(String moduleId, String actionId, String actionUserId, Long departmentIds, Long actionAccountId, String beginDate, String endDate) throws Exception {
        List<Long> userIds = new ArrayList();
        List<Long> departIds = new ArrayList();
        List<Long> accountIds = new ArrayList();
        Integer moduleID = null;
        if (StringUtils.isNotBlank(moduleId)) {
            moduleID = Integer.valueOf(moduleId);
        }

        Integer actionIds = null;
        if (StringUtils.isNotBlank(actionId)) {
            actionIds = Integer.valueOf(actionId);
        }

        this.unit(actionUserId, userIds, departIds, accountIds);
        if (departmentIds != null) {
            departIds.add(departmentIds);
            List<V3xOrgDepartment> v3xOrgDepartmentList = this.orgManager.getChildDepartments(departmentIds, false);
            Iterator var14 = v3xOrgDepartmentList.iterator();

            while(var14.hasNext()) {
                V3xOrgDepartment v3xOrgDepartment = (V3xOrgDepartment)var14.next();
                departIds.add(v3xOrgDepartment.getId());
            }
        }

        if (actionAccountId != null) {
            accountIds.add(actionAccountId);
        }

        if (userIds.size() == 0) {
            userIds = null;
        }

        if (accountIds.size() == 0) {
            accountIds = null;
        }

        if (departIds.size() == 0) {
            departIds = null;
        }

        Date beginTime = this.formatDate(beginDate);
        Date endTime = this.formatDateEndTime(endDate);
        this.clearAppLogs(moduleID, actionIds, userIds, departIds, accountIds, beginTime, endTime);
    }

    public void setOrgManager(OrgManager orgManager) {
        this.orgManager = orgManager;
    }

    public void clearAppLogs(Date date) throws Exception {
        if (date != null) {
            String hql = "delete from " + AppLog.class.getName() + " where actionDate<=:actionDate";
            Map<String, Object> nameParameters = new HashMap();
            nameParameters.put("actionDate", date);
            this.appLogDAO.bulkUpdate(hql, nameParameters, new Object[0]);
        }
    }

    protected void doBatch(List<AppLog> logs) {
        this.appLogDAO.savePatchAll(logs);
    }

    private Integer getActionUserType(Long actionUserId) {
        Integer type = -1;

        try {
            V3xOrgMember actionUser = this.orgManager.getMemberById(actionUserId);
            if (actionUser != null) {
                if (actionUser.isVisitor()) {
                    type = action_user_type.Visitor.ordinal();
                } else if (actionUser.getIsAdmin()) {
                    type = action_user_type.Admin.ordinal();
                } else if (actionUser.getIsInternal()) {
                    type = action_user_type.Member.ordinal();
                } else if (actionUser.isV5External()) {
                    type = action_user_type.ExternalMember.ordinal();
                } else if (actionUser.isVJoinExternal()) {
                    type = action_user_type.VjoinMember.ordinal();
                }
            }
        } catch (BusinessException var4) {
            LOG.error("获取操作人员异常", var4);
        }

        return type;
    }

    private WebAppLog getWebAppLog(AppLog appLog) throws Exception {
                Long accountId = appLog.getActionAccountId();
                Long memberId = appLog.getActionUserId();
                String accountName = "";
                V3xOrgAccount account = this.orgManager.getAccountById(accountId);
                if (account != null) {
                    accountName = account.getName();
                }

                String memberName = "";
                V3xOrgMember member = this.orgManager.getMemberById(memberId);
                if (member != null) {
                    memberName = member.getName();
                    if (member.getIsAdmin()) {
                        memberName = Functions.showMemberNameOnly(memberId);
                        if (this.orgManager.isAdministrator(member.getLoginName(), account)) {
                            memberName = account.getName() + memberName;
                        }
                    } else if (member.isVisitor()) {
                        V3xOrgVisitor visitor = this.orgManager.getVisitorById(memberId);
                        if (visitor != null) {
                            memberName = visitor.getName() + "(" + visitor.getMobile() + ")";
                        }
                    }
                }

                WebAppLog webAppLog = new WebAppLog();
                webAppLog.setId(appLog.getId());
                webAppLog.setAccount(accountName);
                webAppLog.setUser(memberName);
                webAppLog.setActionType(appLog.getActionType());
                webAppLog.setIpAddress(appLog.getIP());
                webAppLog.setActionDesc(appLog.getActionDesc());
                webAppLog.setModelName(appLog.getModuleName());
                webAppLog.setActionTime(appLog.getActionDate());
                webAppLog.setAppLog(appLog);
            return webAppLog;
        }

    private void sendAppLog(WebAppLog webAppLog,User user) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        JSONObject jsonObject = new JSONObject();
        String decodeRs = null;
        String adminType = "";
        if (user.isSystemAdmin())
            adminType = "1";
        else if (user.isSecretAdmin())
            adminType = "2";
        else if (user.isAuditAdmin())
            adminType = "3";
        String authAppCode = "";
        String appLogUrl = "";
        String filePath = SystemEnvironment.getApplicationFolder() + File.separator + "fkmap" + File.separator + "url.properties";
        InputStream in = null;
        try {
            in = new BufferedInputStream(new FileInputStream(filePath));
            Properties p = new Properties();
            p.load(in);
            authAppCode = p.getProperty("authAppCode");
            appLogUrl = p.getProperty("appLogUrl");
        } catch (Exception e) {
            e.printStackTrace();
        }
        int response = 0;
        try {
            PostMethod postMethod = new PostMethod(appLogUrl);
            postMethod.setRequestHeader("Content-Type","application/x-www-form-urlencoded;charset=utf-8");
            NameValuePair[] data = {
                    new NameValuePair("appCode",authAppCode),
                    new NameValuePair("AdminType",adminType),
                    new NameValuePair("operName",webAppLog.getActionType()),
                    new NameValuePair("operTime",sdf.format(webAppLog.getActionTime())),
                    new NameValuePair("detail",webAppLog.getActionDesc()),
                    new NameValuePair("clientIp",webAppLog.getIpAddress()),
                    new NameValuePair("Remark","")
            };
            postMethod.setRequestBody(data);
            HttpClient httpClient = new HttpClient();
            response = httpClient.executeMethod(postMethod);
            if (response==200) {
                InputStream inp = postMethod.getResponseBodyAsStream();
                //这里的编码规则要与上面的相对应
                BufferedReader br = new BufferedReader(new InputStreamReader(inp,"utf-8"));
                String tempbf;
                StringBuffer html = new StringBuffer(100);
                while ((tempbf = br.readLine()) != null) {
                    html.append(tempbf +"\n");

                }
                LOG.info("result=" + html.toString());
                jsonObject = JSONObject.fromObject(html.toString());
                String code = jsonObject.get("code").toString();
                if (!code.equals("0"))
                    LOG.error("------------------------errMsg:"+jsonObject.get("msg"));
                else
                    LOG.info("------------sendAppLog:发送日志成功"+jsonObject.get("msg"));
            }else {
                LOG.error("------------------------errMsg:" + response);
                throw new Exception("HTTP ERROR Status: " + postMethod.getStatusCode() + ":" + postMethod.getStatusText());
            }
        }catch (Exception e) {
            e.printStackTrace();
        }
//        JSONObject json;
//        json.put("appCode",authAppCode);
//        json.put("AdminType",adminType);
//                json.put("operName",webAppLog.getActionType()),
//                json.put("operTime",sdf.format(webAppLog.getActionTime())),
//                json.put("detail",webAppLog.getActionDesc()),
//                json.put("clientIp",webAppLog.getIpAddress())
//        String result = "";
//        HttpPost post = new HttpPost(appLogUrl);
//        try {
//            CloseableHttpClient httpClient = HttpClients.createDefault();
//
//            post.setHeader("Content-Type", "application/json;charset=utf-8");
//            StringEntity postingString = new StringEntity(json.toString(), "utf-8");
//            post.setEntity(postingString);
//            HttpResponse response = httpClient.execute(post);
//
//            InputStream inp = response.getEntity().getContent();
//            BufferedReader br = new BufferedReader(new InputStreamReader(inp, "utf-8"));
//            StringBuilder strber = new StringBuilder();
//            String line = null;
//            while ((line = br.readLine()) != null) {
//                strber.append(line + '\n');
//            }
//            br.close();
//            inp.close();
//            result = strber.toString();
//            if (response.getStatusLine().getStatusCode() != HttpStatus.SC_OK) {
//                result = "服务器异常";
//            }
//        } catch (Exception e) {
//            LOG.error("请求异常");
//            throw new RuntimeException(e);
//        } finally {
//            post.abort();
//        }
    }

}
